"""
Django settings for core project.

Generated by 'django-admin startproject' using Django 2.2.7.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import cv2
import numpy as np
from PIL import Image

from cv.config import get_config
from cv.learner import face_learner

from cv.mtcnn.detect import get_detector_ctx, detect
from cv.mtcnn.recognize import get_model

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'p)lr6b4uq^#wrs$_#7f2u@7dsbtc&@uj!$%j=ne7tn)!t2pnru'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*', ]

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    'app'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'core.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')]
        ,
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'core.wsgi.application'

# Database
# https://docs.djangoproject.com/en/2.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'stud',
        'USER': 'stud',
        'PASSWORD': 'face',
        'HOST': '127.0.0.1',
        'PORT': '5432',
        'ATOMIC_REQUESTS': True
    }
}

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL = '/static/'

MEDIA_URL = '/photos/'
MEDIA_ROOT = os.path.join(BASE_DIR)

# HNSW parameters
INDEX_PATH = '/index.bin'
MAX_ELEMENTS = 1000
# Detector

DETECTOR, ctx = get_detector_ctx()

RECOGNIZER_CONF = get_config(False)

RECOGNIZER = face_learner(RECOGNIZER_CONF, True)
RECOGNIZER.threshold = 1.54

# SYM_THRESH = 0.3
# DIST_THRESH = 1.1

# New thresholds for testing
SYM_THRESH = 5
DIST_THRESH = 0.5

if RECOGNIZER_CONF.device.type == 'cpu':
    RECOGNIZER.load_state(RECOGNIZER_CONF, 'cpu_final.pth', True, True)
else:
    RECOGNIZER.load_state(RECOGNIZER_CONF, 'final.pth', True, True)
RECOGNIZER.model.eval()


def img_embeddings(img_file):
    image = cv2.imread(img_file)
    faces, bboxes, landmarks = detect(DETECTOR, image)
    return RECOGNIZER.get_embeddings(RECOGNIZER_CONF, faces, bboxes, landmarks, True)
